#include <shared/system.h>
#include "DearImguiTestUI.h"

#if ENABLE_IMGUI_TEST

#include "misc.h"
#include "SettingsUI.h"
#include "dear_imgui.h"

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

class DearImguiTestUI : public SettingsUI {
  public:
    void DoImGui() override;

    bool OnClose() override;

  protected:
  private:
    void DoDock(const char *slot_name, ImGuiDockSlot slot);
};

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void DearImguiTestUI::DoImGui() {
    //    ImGui::BeginDockspace();
    //
    //#define TW(X) (this->DoDock(#X,ImGuiDockSlot_##X))
    //
    //    TW(Left);
    //    TW(Right);
    //    TW(Top);
    //    TW(Bottom);
    //
    //#undef TW
    //
    //    ImGui::EndDockspace();
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

bool DearImguiTestUI::OnClose() {
    return false;
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void DearImguiTestUI::DoDock(const char *slot_name, ImGuiDockSlot slot) {
    std::string title = std::string("Dock ") + slot_name;

    ImGui::SetNextDock(slot);
    if (ImGui::BeginDock(title.c_str())) {
        ImGui::Text("Dock: %s", slot_name);
    }
    ImGui::EndDock();
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

std::unique_ptr<SettingsUI> CreateDearImguiTestUI(BeebWindow *beeb_window) {
    (void)beeb_window;

    return std::make_unique<DearImguiTestUI>();
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

#else

std::unique_ptr<SettingsUI> CreateDearImguiTestUI(BeebWindow *) {
    return nullptr;
}

#endif
